import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _createClass from "@babel/runtime/helpers/createClass";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { workspaceSymbol } from '../symbols';
import { Resource as ShellResource, Window as ShellWindow } from '../model';
import { Plugins } from './plugins';
export var Workspace = /*#__PURE__*/function () {
  function Workspace(innerWorkspace) {
    this[workspaceSymbol] = void 0;
    this[workspaceSymbol] = innerWorkspace;
  }
  var _proto = Workspace.prototype;
  _proto.setResourceList = function setResourceList(resourceList) {
    this[workspaceSymbol].setResourceList(resourceList);
  };
  _proto.onResourceListChange = function onResourceListChange(fn) {
    return this[workspaceSymbol].onResourceListChange(fn);
  };
  _proto.onWindowRendererReady = function onWindowRendererReady(fn) {
    return this[workspaceSymbol].onWindowRendererReady(fn);
  };
  _proto.registerResourceType = function registerResourceType(resourceTypeModel) {
    this[workspaceSymbol].registerResourceType(resourceTypeModel);
  };
  _proto.openEditorWindow = /*#__PURE__*/function () {
    var _openEditorWindow = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(resourceName, title, extra, viewName, sleep) {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this[workspaceSymbol].openEditorWindow(resourceName, title, extra, viewName, sleep);
          case 2:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function openEditorWindow(_x, _x2, _x3, _x4, _x5) {
      return _openEditorWindow.apply(this, arguments);
    }
    return openEditorWindow;
  }();
  _proto.openEditorWindowById = function openEditorWindowById(id) {
    this[workspaceSymbol].openEditorWindowById(id);
  };
  _proto.removeEditorWindow = function removeEditorWindow(resourceName, title) {
    this[workspaceSymbol].removeEditorWindow(resourceName, title);
  };
  _proto.removeEditorWindowById = function removeEditorWindowById(id) {
    this[workspaceSymbol].removeEditorWindowById(id);
  };
  _proto.onChangeWindows = function onChangeWindows(fn) {
    return this[workspaceSymbol].onChangeWindows(fn);
  };
  _proto.onChangeActiveWindow = function onChangeActiveWindow(fn) {
    return this[workspaceSymbol].onChangeActiveWindow(fn);
  };
  _proto.onChangeActiveEditorView = function onChangeActiveEditorView(fn) {
    return this[workspaceSymbol].onChangeActiveEditorView(fn);
  };
  _createClass(Workspace, [{
    key: "resourceList",
    get: function get() {
      return this[workspaceSymbol].getResourceList().map(function (d) {
        return new ShellResource(d);
      });
    }
  }, {
    key: "isActive",
    get: function get() {
      return this[workspaceSymbol].isActive;
    }
  }, {
    key: "window",
    get: function get() {
      if (!this[workspaceSymbol].window) {
        return null;
      }
      return new ShellWindow(this[workspaceSymbol].window);
    }
  }, {
    key: "resourceTypeList",
    get: function get() {
      return Array.from(this[workspaceSymbol].resourceTypeMap.values()).map(function (d) {
        var resourceName = d.name,
          resourceType = d.type;
        var _d$resourceTypeModel = d.resourceTypeModel({}, {}),
          description = _d$resourceTypeModel.description,
          editorViews = _d$resourceTypeModel.editorViews;
        return {
          resourceName: resourceName,
          resourceType: resourceType,
          description: description,
          editorViews: editorViews.map(function (d) {
            return {
              viewName: d.viewName,
              viewType: d.viewType || 'editor'
            };
          })
        };
      });
    }
  }, {
    key: "plugins",
    get: function get() {
      return new Plugins(this[workspaceSymbol].plugins, true);
    }
  }, {
    key: "windows",
    get: function get() {
      return this[workspaceSymbol].windows.map(function (d) {
        return new ShellWindow(d);
      });
    }
  }]);
  return Workspace;
}();