import { ILocateEvent } from '@alilc/lowcode-designer';
import { locateEventSymbol } from '../symbols';
import { IPublicModelLocateEvent, IPublicModelDragObject } from '@alilc/lowcode-types';
export default class LocateEvent implements IPublicModelLocateEvent {
    private readonly [locateEventSymbol];
    constructor(locateEvent: ILocateEvent);
    static create(locateEvent: ILocateEvent): IPublicModelLocateEvent | null;
    get type(): string;
    get globalX(): number;
    get globalY(): number;
    get originalEvent(): MouseEvent | DragEvent;
    get target(): Element | null | undefined;
    get canvasX(): number | undefined;
    get canvasY(): number | undefined;
    get dragObject(): IPublicModelDragObject | null;
}
